;@##############################################################################
;#     Filename:       sgpass.asm                                              #
;#     Fileversion:    1.1                                                     #
;#     Filedate:       17.01.07                                                #
;#     Compiled with:  MASM32 9.0                                              #
;#     Description:    Retrieves encoded password from InetAccess-compatible   #
;#                     .ini file and decode it                                 #
;#     Author:         Yuri Konotopov a.k.a. nE0sIghT                          #
;#     License:        GNU General Public License v2                           #
;##############################################################################@
 
comment @
 	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or ( at your option ) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
	@

    	.486                                ; create 32 bit code
    	.model flat, stdcall                ; 32 bit memory model
    	option casemap :none                ; case sensitive

    	include \masm32\include\windows.inc
    	include \masm32\include\masm32.inc
    	include \masm32\include\user32.inc
    	include \masm32\include\kernel32.inc
		include \masm32\include\comdlg32.inc
		include \masm32\include\dialogs.inc
		include macros.asm
    	;include \masm32\include\debug.inc

    	includelib \masm32\lib\masm32.lib
    	includelib \masm32\lib\user32.lib
    	includelib \masm32\lib\kernel32.lib
		includelib \masm32\lib\comdlg32.lib
    	;includelib \masm32\lib\debug.lib

		dlgproc PROTO :DWORD,:DWORD,:DWORD,:DWORD
		DecodeStr PROTO STDCALL :DWORD, :DWORD, :BYTE

	.const
		BUFF_SIZE	equ 8192

	.data?
		hInstance	dd	?

	.data
		fPattern	db	"InetAccess config file",0,"*.ini",0,"All files",0,"*",0,0
		pattern		db	"Password=",0
		pattern1	db	"BindPassHDD=",0
		pattern2	db	"0"
		errTitle	db	"",0
		infoTitle	db	" !",0
		errRdFile 	db	" InetAccess.ini     !",0
		ver1		db	"<= 2.47.6",0
		ver2		db	">= 2.55.7",0

	.code

error	macro	errStr
		invoke MessageBox, NULL, ADDR errStr, ADDR errTitle, MB_OK + MB_ICONERROR + MB_SETFOREGROUND + MB_TOPMOST
		endm

start:
		mov hInstance, FUNC(GetModuleHandle,NULL)
		call main

		invoke ExitProcess,NULL

; 

main proc

    	DialogEx "  InetAccess",\				; Caption
			"Arial",9,\											; Font,?
			WS_POPUP+DS_CENTER+DS_3DLOOK+WS_CAPTION+WS_SYSMENU,\	; Styles
			WS_EX_TOOLWINDOW+WS_EX_TOPMOST,\							; ExStyles
			11,\										; Controls count
			0,0,\										; X:Y co-ordinates
			200,68,\									; Width&Height
			1024										; Memory buffer

		;DlgStatic     quoted_caption,dstyle,tx,ty,wd,ht,ctlID
		DlgStatic ":",SS_LEFT,5,5,80,20,10
		DlgStatic " InetAccess:",SS_LEFT,5,15,80,20,20
		DlgStatic "   HDD:",SS_LEFT,5,25,80,20,30
		DlgStatic ":",SS_LEFT,5,45,80,20,40
		DlgStatic "(C) 2007 nE0sIghT",SS_LEFT,5,58,120,20,40
		DlgStatic "v1.1",SS_LEFT,185,58,20,20,40

		DlgButton "...", WS_TABSTOP+BS_CENTER+BS_VCENTER,180,5,18,10,50

		DlgEdit ES_READONLY+WS_BORDER+ES_CENTER+ES_AUTOHSCROLL,90,5,85,10,60 ;
		DlgEdit ES_READONLY+WS_BORDER+ES_CENTER+ES_AUTOHSCROLL,90,15,85,10,70
		DlgEdit ES_READONLY+WS_BORDER+ES_CENTER+ES_AUTOHSCROLL,90,25,85,10,80
		DlgEdit ES_READONLY+WS_BORDER+ES_CENTER+ES_AUTOHSCROLL,90,45,85,10,90

		CallModalDialog hInstance,0,dlgproc,NULL

		ret

main endp

; 

dlgproc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local hFile:DWORD, filename:DWORD, buff[BUFF_SIZE]:BYTE, iaVer:BYTE,\
		pass[64]:BYTE, ln:DWORD, langId:DWORD, serial:DWORD, pf:BYTE, bf:BYTE

		.if uMsg == WM_INITDIALOG

		.elseif uMsg == WM_COMMAND
			.if wParam == 50
				mov hFile, 0
				mov pf, 0
				mov bf, 0
				mov filename, OpenFileDlg(hWin,hInstance,"  InetAccess.ini", ADDR fPattern)
				cmp byte ptr [eax], 0 	              ; test if 1st byte is zero
				jz return                             ; jump forward if its not

				invoke CreateFile, filename, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING, NULL, NULL
				cmp eax, INVALID_HANDLE_VALUE
				jz err
				mov hFile,eax

				invoke RtlZeroMemory, ADDR buff, BUFF_SIZE
				invoke ReadFile, hFile, ADDR buff, BUFF_SIZE, ADDR ln, NULL

				invoke szLen, ADDR buff
				mov ln,eax
				fn szCmpi, ADDR buff, "[main]", 6
				.if (eax != 0 || ln < 16) 
				invoke szCopy, ADDR errRdFile, ADDR buff
				jmp strerr
				.endif
				mov iaVer, 0
				mov ebx, 0
				.while ebx < ln
				.if (byte ptr [buff+ebx] == 0Dh || byte ptr [buff+ebx] == 0Ah)
				mov byte ptr [buff+ebx],0
				inc iaVer
				.endif
				inc ebx
				.endw
				.if iaVer < 55	; 27 lines * 2 0D0Ah
				mov iaVer, 0
				.else
				mov iaVer, 1
				.endif
				mov ebx, 0
				.while ebx < ln
				.if byte ptr [buff+ebx] != 0
				.if pf == 0
				invoke szCmpi, ADDR byte ptr [buff+ebx], ADDR pattern, (SIZE pattern)-1
				.if eax == 0
				mov pf, 1
				invoke szCopy, ADDR byte ptr [buff+ebx+9], ADDR pass ;"Password=" 9b
				.endif
				.endif
				invoke szCmpi, ADDR byte ptr [buff+ebx], ADDR pattern1, (SIZE pattern)-1
				.if eax == 0
				invoke szCmpi, ADDR byte ptr [buff+ebx+12], ADDR pattern2, 1 ;"BindPassHDD=" 12b
				.if eax != 0
				mov bf, 1
				.endif
				.endif
				.while byte ptr [buff+ebx] != 0
				inc ebx
				.endw
				.endif
				inc ebx
				.endw
				cmp pf, 1
				jz makepass
				invoke szCopy, ADDR errRdFile, ADDR buff
				jmp strerr
makepass:
				invoke GetVolumeInformation, NULL, NULL, 0, ADDR serial, NULL, NULL, NULL, 0
				invoke DecodeStr, ADDR pass, serial, bf

				invoke SetDlgItemText, hWin, 60, filename
				invoke SetDlgItemInt, hWin, 80, bf, FALSE
				invoke SetDlgItemText, hWin, 90, ADDR pass
				.if iaVer == 0
				invoke SetDlgItemText, hWin, 70, ADDR ver1
				.else
				invoke SetDlgItemText, hWin, 70, ADDR ver2
				.endif
				jmp stop
err:
				invoke RtlZeroMemory, ADDR buff, BUFF_SIZE
				invoke GetUserDefaultLangID
				mov langId, eax
				invoke GetLastError
				mov ecx, eax
				invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, ecx, langId, ADDR buff, BUFF_SIZE, NULL
strerr:
				error buff
stop:
				.if hFile != 0
				invoke CloseHandle, hFile
				mov hFile, 0
				.endif
			.endif

		.elseif uMsg == WM_CLOSE
			quit_dialog:
			invoke EndDialog,hWin,0

		.endif

		xor eax, eax
return:
		ret

dlgproc endp

; 

DecodeStr\
		proc USES ebx ecx edx, ptrString:DWORD, serialN:DWORD, useHDD:BYTE
		local strdc[100]:BYTE, len:DWORD, c1:BYTE, c2:BYTE, serial_c[4]:BYTE

		invoke szLen, ptrString
		mov len, eax
		mov eax, serialN
		mov dword ptr [serial_c], eax
		mov ecx, 0
		mov ebx, ptrString
		.while ecx < len
		mov al, [ebx+ecx]
		mov c1, al
		sub c1, 50
		mov al, [ebx+ecx+1]
		mov c2, al
		sub c2, 50
		shl c2, 4
		mov al, c2
		add c1, al
		mov eax, ecx
		mov dl, 2
		div dl
		mov dl, c1
		mov [strdc+eax], dl
		add ecx, 2
		.endw
		mov eax, len
		mov bl, 2
		div bl
		mov len, eax
		mov bl, 0
		mov ecx, 0
		.while ecx < len
		cmp useHDD, 1
		jz hdd
		xor [strdc+ecx], 49
		jmp cnt
hdd:
		mov al, bl
		mov bh, 4
		div bh
		movzx eax, ah
		mov dl, [serial_c+eax]
		xor  [strdc+ecx], dl
		inc bl
cnt:
		inc ecx
		.endw
		mov [strdc+ecx], 0
		invoke szCopy, ADDR strdc, ptrString
		mov eax, ptrString
		ret
DecodeStr endp

; 

end start

